var objOSB =
{
	InArray: function(objItem, aTestArray)
	{
		for (var objIndex in aTestArray)
		{
			if (objItem == aTestArray[objIndex]) return objIndex;
		}

		return false;
	},

	InitServices: function()
	{
		window.removeEventListener('load', objOSB.InitServices, false);

		objOSB.prefService = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch('organizestatusbar.');
		objOSB.ndStatusBar = document.getElementById('status-bar');

		objOSB.ndStatusBar.addEventListener('DOMNodeInserted', objOSB.ModifiedStatusBar, false);
		objOSB.ndStatusBar.addEventListener('DOMNodeRemoved', objOSB.ModifiedStatusBar, false);

		objOSB.aDefaultItemList = [];
		objOSB.aDefaultCollapsed = {};

		objOSB.InitOrganize();
	},

	InitOrganize: function()
	{
		objOSB.Init();
		objOSB.Organize(null);

		return true;
	},

	Init: function()
	{
		objOSB.aDefaultCollapsed = {};

		var nIndex;
		var nNoID = 0;
		var aPref = [];
		var aCurrentID = [];

		if (objOSB.prefService.prefHasUserValue('StatusBar'))
		{
			aPref = objOSB.prefService.getCharPref('StatusBar').split(',');
			for (nIndex = 0; aPref[nIndex]; ++nIndex)
			{
				aCurrentID.push(aPref[nIndex].split(':')[0]);
			}
		}

		var aStatusBarPanels = objOSB.ndStatusBar.childNodes;
		for (nIndex = 0; aStatusBarPanels[nIndex]; ++nIndex)
		{
			if ((aStatusBarPanels[nIndex].nodeName == 'keyset')
			|| (aStatusBarPanels[nIndex].nodeName == 'toolbar')
			|| (aStatusBarPanels[nIndex].nodeName == 'stringbundle')
			|| (aStatusBarPanels[nIndex].nodeName == 'menupopup')
			|| (aStatusBarPanels[nIndex].nodeName == 'popupset')
			|| (aStatusBarPanels[nIndex].nodeName == 'popup'))
			{
				continue;
			}

			if ((aStatusBarPanels[nIndex].id == null) || (!aStatusBarPanels[nIndex].id.length)) aStatusBarPanels[nIndex].id = 'osb-noid-' + nNoID++;
			objOSB.aDefaultCollapsed[aStatusBarPanels[nIndex].id] = (objOSB.InArray(aStatusBarPanels[nIndex].id + ':0', aPref) === false) && (aStatusBarPanels[nIndex].getAttribute('collapsed') == 'true');
			if (objOSB.InArray(aStatusBarPanels[nIndex].id, objOSB.aDefaultItemList) === false) objOSB.aDefaultItemList.push(aStatusBarPanels[nIndex].id);
			if (objOSB.InArray(aStatusBarPanels[nIndex].id, aCurrentID) === false) aPref.push(aStatusBarPanels[nIndex].id + ':1');
		}

		objOSB.prefService.setCharPref('StatusBar', aPref.join(','));

		return true;
	},

	Organize: function(aItemList)
	{
		if (!aItemList) aItemList = objOSB.prefService.getCharPref('StatusBar').split(',');
		var aStatusBar = objOSB.ndStatusBar.childNodes;

		var bSort = false, nOrder, nNext, ndOrderItem, ndNextItem;
		for (var nIndex = 0; aItemList[nIndex]; ++nIndex)
		{
			ndOrderItem = document.getElementById(aItemList[nIndex].split(':')[0]);
			if (!ndOrderItem || !ndOrderItem.parentNode || !(ndOrderItem.parentNode == objOSB.ndStatusBar)) continue;

			ndOrderItem.removeEventListener('DOMAttrModified', objOSB.ModifiedAttribute, false);
			ndOrderItem.setAttribute('collapsed', ((aItemList[nIndex].split(':')[1] == '0') || objOSB.aDefaultCollapsed[ndOrderItem.id]));
			ndOrderItem.addEventListener('DOMAttrModified', objOSB.ModifiedAttribute, false);

			if (bSort || !aItemList[nIndex + 1]) continue;

			ndNextItem = document.getElementById(aItemList[nIndex + 1].split(':')[0]);
			if (!ndNextItem) continue;

			nOrder = objOSB.InArray(ndOrderItem, aStatusBar);
			nNext = objOSB.InArray(ndNextItem, aStatusBar);
			bSort = (nOrder !== false) && (nNext !== false) && (nOrder > nNext);
		}

		if (bSort)
		{
			objOSB.ndStatusBar.removeEventListener('DOMNodeInserted', objOSB.ModifiedStatusBar, false);
			objOSB.ndStatusBar.removeEventListener('DOMNodeRemoved', objOSB.ModifiedStatusBar, false);

			var ndInserted;
			for (nIndex = 0; nIndex < aItemList.length; ++nIndex)
			{
				ndOrderItem = document.getElementById(aItemList[nIndex].split(':')[0]);
				if (!ndOrderItem || !ndOrderItem.parentNode || !(ndOrderItem.parentNode == objOSB.ndStatusBar)) continue;

				ndOrderItem.removeEventListener('DOMAttrModified', objOSB.ModifiedAttribute, false);
				ndInserted = objOSB.ndStatusBar.appendChild(objOSB.ndStatusBar.removeChild(ndOrderItem));
				ndInserted.addEventListener('DOMAttrModified', objOSB.ModifiedAttribute, false);
			}

			objOSB.ndStatusBar.addEventListener('DOMNodeInserted', objOSB.ModifiedStatusBar, false);
			objOSB.ndStatusBar.addEventListener('DOMNodeRemoved', objOSB.ModifiedStatusBar, false);
		}

		return true;
	},

	ModifiedAttribute: function(e)
	{
		if (!e.target.parentNode) return true;
		if (e.target.parentNode.id != 'status-bar') return true;

		var aPref = objOSB.prefService.getCharPref('StatusBar').split(',');

		e.target.removeEventListener('DOMAttrModified', objOSB.ModifiedAttribute, false);
		if ((objOSB.InArray(e.target.id + ':0', aPref) !== false) && (e.attrName == 'collapsed') && (!e.newValue || (e.newValue == 'false'))) e.target.setAttribute('collapsed', true);
		e.target.addEventListener('DOMAttrModified', objOSB.ModifiedAttribute, false);

		return true;
	},

	ModifiedStatusBar: function(e)
	{
		if (!e.target.parentNode) return true;
		if (e.target.parentNode.id != 'status-bar') return true;

		objOSB.Init();
		if ((objOSB.InArray(e.target.id, objOSB.aDefaultItemList) !== false)) objOSB.Organize(null);

		return true;
	},

	Options: function()
	{
		window.openDialog('chrome://osb/content/osbOptions.xul', 'osb-options-dialog', 'centerscreen,chrome,modal');

		return true;
	}
};

window.addEventListener('load', objOSB.InitServices, false);
